import store from '@/store'
/**
 * Use meta.role to determine if the current user has permission
 * @param roles
 * @param routeRoles
 */
function hasPermission(roles, routeRoles) {
  if (Array.isArray(routeRoles)) {
    return roles.some(role => routeRoles.includes(role))
  } else {
    return true
  }
}
export default class BeforeEnter {
  constructor(opt) {
    this.opt = opt || {}
  }

  async update(to, from, next) {
    const isLogin = store.state.user.isLogin || (await store.dispatch('checkLogin'))
    const hasRoles = store.state.user.hasRoles || (await store.dispatch('checkRoles'))
    const loginUrl = `${webConf.others.loginUrl}?rd=${encodeURIComponent(window.location.href)}`
    if (!isLogin || !hasRoles) {
      window.location.href = loginUrl
      // next(loginUrl)
      return
    } else {
      const roles = store.state.user.roles.map(item => item.name)
      if (!hasPermission(roles, to.meta.roles)) {
        // next(loginUrl)
        window.location.href = loginUrl
        return
      }
      next()
    }
    store.dispatch('setUserRoles')
    next()
  }
}
